//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2015.06.09 at 11:11:31 AM CEST 
//


package net.ihe.gazelle.tempmodel.org.decor.art.model;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import net.ihe.gazelle.tempmodel.org.decor.art.behavior.HasItem;
import net.ihe.gazelle.tempmodel.org.decor.art.behavior.HasParent;


/**
 * <p>Java class for IncludeDefinition complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="IncludeDefinition"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="desc" type="{}FreeFormMarkupWithLanguage" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;element ref="{}item" minOccurs="0"/&gt;
 *         &lt;element ref="{}example" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;choice maxOccurs="unbounded" minOccurs="0"&gt;
 *           &lt;element name="constraint" type="{}FreeFormMarkupWithLanguage" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;/choice&gt;
 *       &lt;/sequence&gt;
 *       &lt;attGroup ref="{}MultiplicityRangeOptional"/&gt;
 *       &lt;attribute name="ref" use="required" type="{}BasicIdOrOid" /&gt;
 *       &lt;attribute name="flexibility" type="{}StaticOrDynamicFlexibility" default="dynamic" /&gt;
 *       &lt;attribute name="conformance" type="{}ConformanceType" /&gt;
 *       &lt;attribute name="isMandatory" type="{http://www.w3.org/2001/XMLSchema}boolean" default="false" /&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "IncludeDefinition", propOrder = {
    "desc",
    "item",
    "example",
    "constraint"
})
@XmlRootElement(name="IncludeDefinitionType")
public class IncludeDefinition implements HasItem, HasParent {

    private List<FreeFormMarkupWithLanguage> desc;
    private Item item;
    private List<Example> example;
    private List<FreeFormMarkupWithLanguage> constraint;
    @XmlAttribute(name = "ref", required = true)
    private String ref;
    @XmlAttribute(name = "flexibility")
    private String flexibility;
    @XmlAttribute(name = "conformance")
    private ConformanceType conformance;
    @XmlAttribute(name = "isMandatory")
    private Boolean isMandatory;
    @XmlAttribute(name = "minimumMultiplicity")
    private Integer minimumMultiplicity;
    @XmlAttribute(name = "maximumMultiplicity")
    private String maximumMultiplicity;
    
    @XmlTransient
	private Object parentObject;
    
    public Object getParentObject() {
		return parentObject;
	}

	public void setParentObject(Object parentComponent) {
		this.parentObject = parentComponent;
	}
	
	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
		this.parentObject = parent;
	}

    /**
     * Gets the value of the desc property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the desc property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getDesc().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link FreeFormMarkupWithLanguage }
     * @return object list {@link FreeFormMarkupWithLanguage }
     * 
     */
    public List<FreeFormMarkupWithLanguage> getDesc() {
        if (desc == null) {
            desc = new ArrayList<>();
        }
        return this.desc;
    }

    /**
     * Gets the value of the item property.
     * 
     * @return
     *     possible object is
     *     {@link Item }
     *     
     */
    public Item getItem() {
        return item;
    }

    /**
     * Sets the value of the item property.
     * 
     * @param value
     *     allowed object is
     *     {@link Item }
     *     
     */
    public void setItem(Item value) {
        this.item = value;
    }

    /**
     * Gets the value of the example property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the example property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExample().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Example }
     * @return object list {@link Example }
     * 
     */
    public List<Example> getExample() {
        if (example == null) {
            example = new ArrayList<>();
        }
        return this.example;
    }

    /**
     * Gets the value of the constraint property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the constraint property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getConstraint().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link FreeFormMarkupWithLanguage }
     * @return object list {@link FreeFormMarkupWithLanguage }
     * 
     */
    public List<FreeFormMarkupWithLanguage> getConstraint() {
        if (constraint == null) {
            constraint = new ArrayList<>();
        }
        return this.constraint;
    }

    /**
     * Gets the value of the ref property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getRef() {
        return ref;
    }

    /**
     * Sets the value of the ref property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setRef(String value) {
        this.ref = value;
    }

    /**
     * Gets the value of the flexibility property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFlexibility() {
        if (flexibility == null) {
            return "dynamic";
        } else {
            return flexibility;
        }
    }

    /**
     * Sets the value of the flexibility property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFlexibility(String value) {
        this.flexibility = value;
    }

    /**
     * Gets the value of the conformance property.
     * 
     * @return
     *     possible object is
     *     {@link ConformanceType }
     *     
     */
    public ConformanceType getConformance() {
        return conformance;
    }

    /**
     * Sets the value of the conformance property.
     * 
     * @param value
     *     allowed object is
     *     {@link ConformanceType }
     *     
     */
    public void setConformance(ConformanceType value) {
        this.conformance = value;
    }

    /**
     * Gets the value of the isMandatory property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isIsMandatory() {
        if (isMandatory == null) {
            return false;
        } else {
            return isMandatory;
        }
    }
    
    public Boolean getIsMandatory() {
    	return isMandatory;
    }

    /**
     * Sets the value of the isMandatory property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setIsMandatory(Boolean value) {
        this.isMandatory = value;
    }

    /**
     * Gets the value of the minimumMultiplicity property.
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getMinimumMultiplicity() {
        return minimumMultiplicity;
    }

    /**
     * Sets the value of the minimumMultiplicity property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setMinimumMultiplicity(Integer value) {
        this.minimumMultiplicity = value;
    }

    /**
     * Gets the value of the maximumMultiplicity property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getMaximumMultiplicity() {
        return maximumMultiplicity;
    }

    /**
     * Sets the value of the maximumMultiplicity property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setMaximumMultiplicity(String value) {
        this.maximumMultiplicity = value;
    }

}
